clear;

nh=100;  nepochs=250;  lrate=0.01;  momentum=0;

%load data from text file and rearrange into matrix ( [X, Y, letter] )
load pattern1.txt;
letters = permute( reshape( pattern1, [12 26 13]), [1 3 2]);

%train rbm with nh hidden units for nepochs presentations of the 26 letters
[rbm, output] = trainrbm(reshape(letters,[12*13 26]), nh, nepochs, lrate, momentum);

%plot reconstructions of noisy letters (20% of bits randomly flipped)
%In reconstructInput we introduce temperature ...
%The lower the temperature the less stochastic the RBM is.
%Here we use a relatively low temperature of 1/4 to decrease the noise in
%the reconstructions. (during training we used an implicit temperature of 1)
r = randomFlipMatrix(round(.2*12*13));
noisy_letters = abs(letters - reshape(r,[12 13 26]));
reconstructInput(rbm, noisy_letters, 1, 4, 1/4);
